<?php
class BookList implements Iterator,Countable,SeekableIterator,ArrayAccess
{
	private $pages = array();
	private $currentPag = 1;
	private $database = null;
	private $booksPerPage = 10;
	private $totalBooks = 0;
	private $deletions = array();
  public function __construct($database)
  {
		$this->database = $database;
		if($result = $this->database->query("select count(*) from books"))
		{
			if($row = $result->fetch_row())
			{
				$this->totalBooks = $row[0];
			}
		}
  }
	/* ӿ */
  function rewind()
  {
		$this->currentPage = 1;
		if( array_key_exists(1,$this->pages) )
		{
			reset($this->pages[$i]);
		}
  }
  function current()
  {
		return current($this->touchPage());
  }
  function key()
  {
		return key($this->touchPage()) + $this->booksPerPage * ($this->currentPage -1);
  }
  function next()
  {
		$page = & $this->touchPage();
		next($page);
		if( key($page) === null && count($page) == $this->booksPerPage)
		{
			$this->currentPage++;
			$page = & $this->touchPage();
			reset($page);
		}
		return current($page);
  }
  function valid()
  {
		$page = & $this->touchPage();
		return (key($page) !== null);
  }
  //ѯ
  private function & touchPage($pageNo = false)
  {
  	if($pageNo === false)
  	{
  		$pageNo = $this->currentPage;
  	}

		if(! array_key_exists($pageNo,$this->pages))
		{
			if( $pageNo > ceil($this->count() / $this->booksPerPage))
			{
				$this->pages[$pageNo] = array();
			}else
			{
        $start = ($pageNo-1)* $this->booksPerPage + $this->getAdjustmentForPage($pageNo);
				$sql = "select `ISBN`,title,(select group_concat(`name`) from `book_authors` as t2 join `authors` as t3 on t2.authorid = t3.id where t2.bookid = t1.id) as `author`,`t4`.`name` as publisher from `books` as t1 join `publisher` as t4 on t1.publisher = t4.id limit $start,{$this->booksPerPage}";
				$result = $this->database->query($sql);
				while ($row = $result->fetch_array(MYSQLI_ASSOC))
				{
					$temp_array[] = $row;
				}
        $this->pages[$pageNo] = $temp_array;
			}
		}
		$temp = & $this->pages[$pageNo];
		return $temp;
  }
  /* ӿ */
  public function count()
  {
		return $this->totalBooks;
  }
  
  /* ӿ */
  public function seek($index)
  {
		if($index < 0 || $index > $this->totalBooks)
		{
			throw new OutOfBoundsException();
		}
		$this->currentPage = (int) floor($index / $this->booksPerPage) +1;
		$page = & $this->touchPage();
		reset($page);
		for($i = $index % $this->booksPerPage; $i>0 ; $i--)
		{
			next($page);
		}
  }
  /* ʽӿ*/
  public function offsetExists($offset)
  {
  	echo 'offsetExists';
  	return ( $offset > 0 && $offset < count($this) );
  }
  public function offsetGet($offset)
  {
  	echo 'offsetGet';
  	$pageOfOffset = (int)floor($offset / $this->booksPerPage) + 1;
  	$page = & $this->touchPage($pageOfOffset);
  	return $page[$offset / $this->booksPerPage];
  	
  }
  public function offsetSet($offset,$newValue)
  {
  	echo 'offsetSet';  	
  	$pageOfOffset = (int)floor($offset / $this->booksPerPage) + 1;
  	$page = & $this->touchPage($pageOfOffset);
  	$page[$offset % $this->booksPerPage] = $newValue;
  }
  public function offsetUnset($offset)
  {
  	echo 'offsetUnset';   	
  	$pageOfOffset = (int)floor($offset / $this->booksPerPage) + 1;
  	$page = & $this->touchPage($pageOfOffset);
  	$this->deletions[$pageOfOffset] ++;
  	ksort($this->deletions);
  	unset($page[$offset % $this->booksPerPage]);
  	$page = array_values($page);
  	while(is_array($this->pages[$pageOfOffset+1]))
  	{
  		$this->pages[$pageOfOffset][] = array_shift($this->pages[++$pageOfOffset]);
  	}
  	$record = ($pageOfOffset -1)*$this->booksPerPage + count($this->pages[$pageOfOffset]) + $this->getAdjustmentForPage($pageOfOffset);
  	if($result = $this->database->query("select * from books limit $record,1"))
  	{
  		$this->pages[$pageOfOffset][] = $result->fetch_object();
  	}
  	$this->totalBooks --;
  }
  private function getAdjustmentForPage($pageNo)
  {
  	$adjust = 0;
  	for(reset($this->deletions);key($this->deletions) !== null && key($this->deletions) < $pageNo;next($this->deletions))
  	{
  		$adjust += current($this->deletions);
  	}
  	return $adjust;
  }
}
?>
