<?php
	require_once dirname(__FILE__).'/booklist.class.php';
	require_once dirname(__FILE__).'/page.class.php';
	$dbConn = new mysqli('localhost','root','123456','booklist');
	$dbConn->query("set names utf8");
	$booksPerPage = 10;
	$page = isset($_GET['page']) ? $_GET['page'] : 1;
	$bookList = new BookList($dbConn);
	$bookPage = new Page($bookList,$page,$booksPerPage);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title> 图书俱乐部 </title>
</head>
<body>
	<p>Showing books</p>
	<?php
		printf('%d-%d of %d',$bookPage->getFirstIndex(),$bookPage->getLastIndex(),count($bookList));
	?>
	<table>
		<thead>
			<th>Title</th>
			<th>Author</th>
			<th>Publisher</th>
		</thead>
		<tbody>
			<?php
				foreach($bookPage as $key => $book)
				{
					printf('<tr><td>%s</td><td>%s</td><td>%s</td></tr>',$book['title'],$book['author'],$book['publisher']);
				}
			?>
		</tbody>
	</table>
	<ul>
		<?php
			$totalPages = ceil(count($bookList) / $booksPerPage);
			if($page > 1)
			{
				printf('<li><a href="?page=%d">Prev</a></li>',$page-1);
			}
			for($i = 1 ; $i <= $totalPages ; $i++)
			{
				if( $i == $page)
				{
					printf('<li>%d</li>', $i);
				} else {
					printf('<li><a href="?page=%d">%d</a></li>',$i,$i);
				}
			}
			if($page < $totalPages){
				printf('<li><a href="?page=%d">Next</a></li>', $page+1);
			}
		?>
	</ul>
</body>
</html>
<!--
//系统执行步骤
一、实例化bookList类和page类，bookList实例连接数据库，bookPage实例传入bookList实例，当前页，偏移量
二、外部迭代类bookPage实例调用了rewind()方法，通过getInnerIterator()方法获取内部迭代实例，调用了bookList实例的seek方法
三、bookList实例的seek方法设置了当前索引并获取索引内容
四、bookPage实例的foreach执行了valid()方法，该方法调用了bookList实例的key方法,返回当前迭代实例的key
五、bookPage实例通过验证，执行current()方法，该方法调用了bookList实例的current方法,返回当前内容
六、bookPage实例接着key()方法，该方法调用了bookList实例的key方法,返回当前主键
六、bookPage实例进入next方法，该方法调用了bookList实例的next方法,指针下移





-->